#include scene_sessions24/util.glsl

vec2 fisheye_main(vec2 UV, float t) {
    float i_t = floor(t);
    float f_t = fract(t);

    vec2 p = UV*rot(-t*0.25);

    float sca = mix(rand(i_t).x, rand(i_t+1.0).x, elastic(f_t))*3.0;
    p *= length(p)*(2.0+sca);

    return p;
}